(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser/animations'), require('@angular/animations/browser')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/platform-browser/animations', '@angular/animations/browser'], factory) :
	(factory((global.ngx = global.ngx || {}, global.ngx.noAnimation = global.ngx.noAnimation || {}),global.ng.core,global._angular_platformBrowser_animations,global._angular_animations_browser));
}(this, (function (exports,_angular_core,_angular_platformBrowser_animations,_angular_animations_browser) { 'use strict';

/**
 * @param {?} browserDetectService
 * @param {?=} config
 * @return {?}
 */
function animationFactory(browserDetectService, config) {
    // const noop = AnimationDriver.NOOP;
    var /** @type {?} */ driver = new _angular_animations_browser.ɵWebAnimationsDriver();
    var /** @type {?} */ noop = new _angular_animations_browser.ɵNoopAnimationDriver();
    var /** @type {?} */ isSupported = browserDetectService.isBrowserSupport(window.navigator.userAgent);
    if (!isSupported || (config && config.disable)) {
        return noop;
    }
    else {
        return driver;
    }
    // return {
    //     animate: (element: any,
    //         keyframes: Array<{ [key: string]: string | number; }>,
    //         duration: number, delay: number, easing: string, previousPlayers?: any[]) => {
    //         if (!isSupported || (config && config.disable)) {
    //             console.log('no animation');
    //             return noop.animate(element, keyframes, duration, delay, easing, previousPlayers);
    //         } else {
    //             console.log('animation');
    //             return driver.animate(element, keyframes, duration, delay, easing, previousPlayers);
    //         }
    //     }
    // };
}

var BrowserDetectService = (function () {
    function BrowserDetectService() {
    }
    /**
     * @param {?} ua
     * @return {?}
     */
    BrowserDetectService.prototype.isBrowserSupport = function (ua) {
        // tslint:disable-next-line:no-string-literal
        if (!!window['chrome'] && !!window['chrome']['webstore']) {
            return true;
        }
        else if (ua.indexOf('MSIE') !== -1) {
            return ua.indexOf('MSIE 10') !== -1; // filter out all IE but IE10
        }
        else if (ua.indexOf('Edge') !== -1 || ua.indexOf('Trident') !== -1) {
            return true; // IE11 and Edge
        }
        else if (ua.indexOf('Firefox') !== -1) {
            var /** @type {?} */ match = /((?!Gecko.+)Firefox|Gecko(?!.+Firefox))(?: |\/)([\d]+)/.exec(ua);
            var /** @type {?} */ ver = +match[2];
            return !!match[1] && !isNaN(ver) && ver >= 27; // Firefox 27+
        }
        else if (ua.indexOf('Safari') !== -1) {
            var /** @type {?} */ match = /(?:iPod|iPhone|iPad).+Version\/(\d+\.\d+).*Safari/.exec(ua); // iOS safari 7.1+
            var /** @type {?} */ ver = match ? +match[1] : NaN;
            if (!isNaN(ver)) {
                return ver >= 7.1;
            }
            match = /Version\/(\d+)\.\d+(?:\.\d+)?.*Safari/.exec(ua); // OS X Safari 9+
            ver = match ? +match[1] : 0;
            if (!isNaN(ver)) {
                return ver >= 9;
            }
        }
        return false;
    };
    return BrowserDetectService;
}());
BrowserDetectService.decorators = [
    { type: _angular_core.Injectable },
];
/**
 * @nocollapse
 */
BrowserDetectService.ctorParameters = function () { return []; };

var CONFIG_TOKEN = new _angular_core.InjectionToken('config');
var BrowserSupportedAnimationsModule = (function () {
    function BrowserSupportedAnimationsModule() {
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    BrowserSupportedAnimationsModule.forRoot = function (config) {
        return {
            ngModule: BrowserSupportedAnimationsModule,
            providers: [
                BrowserDetectService,
                { provide: CONFIG_TOKEN, useValue: config },
                { provide: _angular_animations_browser.AnimationDriver, useFactory: animationFactory, deps: [BrowserDetectService, CONFIG_TOKEN] }
            ]
        };
    };
    return BrowserSupportedAnimationsModule;
}());
BrowserSupportedAnimationsModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [_angular_platformBrowser_animations.BrowserAnimationsModule]
            },] },
];
/**
 * @nocollapse
 */
BrowserSupportedAnimationsModule.ctorParameters = function () { return []; };

exports.BrowserSupportedAnimationsModule = BrowserSupportedAnimationsModule;
exports.animationFactory = animationFactory;

Object.defineProperty(exports, '__esModule', { value: true });

})));
