import { BrowserDetectService } from './browser-detect.service';
import {
    AnimationDriver,
    ɵAnimationEngine,
    ɵNoopAnimationEngine,
    ɵWebAnimationsDriver
} from '@angular/animations/browser';
import { BrowserSupportedAnimationsModule, CONFIG_TOKEN, IAnimationConfig, animationFactory } from './';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { async, ComponentFixture, fakeAsync, TestBed, tick } from '@angular/core/testing';
import { BrowserModule, DOCUMENT, By } from '@angular/platform-browser';
import { Component, trigger, state, style, transition, animate } from '@angular/core';
import { WebAnimationsDriver } from "@angular/animations/browser/src/render/web_animations/web_animations_driver";
import { AnimationEngine } from "@angular/animations/browser/src/animation_engine";


@Component({
    // tslint:disable-next-line:component-selector
    selector: 'test-component',
    template: `<button (click)="show=!show">Fly in</button><h1 [@flyInOut] *ngIf="show">test</h1>`,
    // tslint:disable-next-line:object-literal-sort-keys
    animations: [
        trigger('flyInOut', [
            state('in', style({ transform: 'translateX(0)' })),
            transition('void => *', [
                style({ transform: 'translateX(-100%)' }),
                animate(100)
            ]),
            transition('* => void', [
                animate(100, style({ transform: 'translateX(100%)' }))
            ])
        ])
    ]
})
export class TestComponent {
    public show: boolean;
}

function getFixture(mockedService: BrowserDetectService, mockedConfig: IAnimationConfig) {
    return TestBed.configureTestingModule({
        declarations: [TestComponent],
        imports: [
            BrowserAnimationsModule,
        ],
        providers: [
            { provide: BrowserDetectService, useValue: mockedService },
            { provide: CONFIG_TOKEN, useValue: undefined },
            { provide: AnimationDriver, useFactory: animationFactory, deps: [BrowserDetectService, CONFIG_TOKEN] }
        ]
    }).createComponent(TestComponent);
}

describe('factory: animationFactory', () => {
    let spy: jasmine.Spy;
    let config: IAnimationConfig;
    let fixture: ComponentFixture<TestComponent>;
    let engine: any;
    let browserDetectService: BrowserDetectService;
    let browserDetectServiceDouble: BrowserDetectService;
    let button: HTMLButtonElement;

    // describe('if browser is not supported', () => {
    //     beforeEach(() => {
    //         // create a mock service
    //         browserDetectServiceDouble = {
    //             isBrowserSupport: (ua: string) => false
    //         };
    //         fixture = getFixture(browserDetectServiceDouble, undefined);
    //         engine = fixture.debugElement.injector.get(ɵAnimationEngine);
    //         browserDetectService = fixture.debugElement.injector.get(BrowserDetectService);
    //         button = fixture.debugElement.nativeElement.querySelector('button');
    //         fixture.detectChanges();
    //     });
    //     it('isBrowserSupport should be false', () => {
    //         expect(browserDetectService.isBrowserSupport('')).toBeFalsy();
    //         expect(engine instanceof ɵNoopAnimationEngine).toBeTruthy();
    //         console.log('engine', engine);
    //     });
    //     it('should not detect ng-animating...', fakeAsync(() => {

    //         button.click();
    //         fixture.detectChanges();
    //         tick(500000);

    //         let element = fixture.debugElement.query(By.css('h1'));

    //         console.log(element.nativeElement);
    //         fixture.detectChanges();
    //         fixture.whenStable().then(() => {
    //             tick(500);

    //             fixture.detectChanges();
    //             fixture.whenStable().then(() => {

    //                 let h1 = document.querySelector('h1');

    //                 console.log(h1);

    //             });
    //             //expect(element).toBeNull();
    //         });
    //     }));
    // });
    // describe('if browser is supported', () => {
    //     beforeEach(() => {
    //         // create a mock service
    //         browserDetectServiceDouble = {
    //             isBrowserSupport: (ua: string) => true
    //         };
    //         fixture = getFixture(browserDetectServiceDouble, undefined);
    //         browserDetectService = fixture.debugElement.injector.get(BrowserDetectService);
    //         button = fixture.debugElement.nativeElement.querySelector('button');
    //         fixture.detectChanges();
    //     });

    //     it('isBrowserSupport should be true', () => {
    //         expect(browserDetectService.isBrowserSupport('')).toBeTruthy();
    //     });

    //     it('should detect ng-animating...', async(() => {
    //         button.click();
    //         fixture.detectChanges();
    //         fixture.whenStable().then(() => {
    //             let element = fixture.debugElement.query(By.css('.ng-animating'));
    //             expect(element.nativeElement).toBeTruthy();
    //         });
    //     }));
    // });

});

