import { BrowserDetectService } from './browser-detect.service';
import { AnimationDriver, ɵNoopAnimationDriver, ɵWebAnimationsDriver } from '@angular/animations/browser';
// import { isBrowserSupport } from "./browser-detect";
export interface IAnimationConfig {
    disable: boolean;
}
export function animationFactory(browserDetectService: BrowserDetectService, config?: IAnimationConfig): any {
    // const noop = AnimationDriver.NOOP;
    const driver = new ɵWebAnimationsDriver();
    const noop = new ɵNoopAnimationDriver();

    const isSupported = browserDetectService.isBrowserSupport(window.navigator.userAgent);
    if (!isSupported || (config && config.disable)) {
        return noop;
    } else {
        return driver;
    }
    // return {
    //     animate: (element: any,
    //         keyframes: Array<{ [key: string]: string | number; }>,
    //         duration: number, delay: number, easing: string, previousPlayers?: any[]) => {

    //         if (!isSupported || (config && config.disable)) {
    //             console.log('no animation');
    //             return noop.animate(element, keyframes, duration, delay, easing, previousPlayers);
    //         } else {
    //             console.log('animation');
    //             return driver.animate(element, keyframes, duration, delay, easing, previousPlayers);
    //         }
    //     }
    // };
};
